#!/usr/bin/env python




##################################################
## DEPENDENCIES
import sys
import os
import os.path
try:
    import builtins as builtin
except ImportError:
    import __builtin__ as builtin
from os.path import getmtime, exists
import time
import types
from Cheetah.Version import MinCompatibleVersion as RequiredCheetahVersion
from Cheetah.Version import MinCompatibleVersionTuple as RequiredCheetahVersionTuple
from Cheetah.Template import Template
from Cheetah.DummyTransaction import *
from Cheetah.NameMapper import NotFound, valueForName, valueFromSearchList, valueFromFrameOrSearchList
from Cheetah.CacheRegion import CacheRegion
import Cheetah.Filters as Filters
import Cheetah.ErrorCatchers as ErrorCatchers
from xpdeint.ScriptElement import ScriptElement

##################################################
## MODULE CONSTANTS
VFFSL=valueFromFrameOrSearchList
VFSL=valueFromSearchList
VFN=valueForName
currentTime=time.time
__CHEETAH_version__ = '2.4.4'
__CHEETAH_versionTuple__ = (2, 4, 4, 'development', 0)
__CHEETAH_genTime__ = 1350619620.471143
__CHEETAH_genTimestamp__ = 'Fri Oct 19 15:07:00 2012'
__CHEETAH_src__ = '/Users/graham/Library/XMDS/src/xmds2/admin/staging/xmds-2.1.2/xpdeint/Features/Transforms/Basis.tmpl'
__CHEETAH_srcLastModified__ = 'Sat Feb  4 18:39:07 2012'
__CHEETAH_docstring__ = 'Autogenerated by Cheetah: The Python-Powered Template Engine'

if __CHEETAH_versionTuple__ < RequiredCheetahVersionTuple:
    raise AssertionError(
      'This template was compiled with Cheetah version'
      ' %s. Templates compiled before version %s must be recompiled.'%(
         __CHEETAH_version__, RequiredCheetahVersion))

##################################################
## CLASSES

class Basis(ScriptElement):

    ##################################################
    ## CHEETAH GENERATED METHODS


    def __init__(self, *args, **KWs):

        super(Basis, self).__init__(*args, **KWs)
        if not self._CHEETAH__instanceInitialized:
            cheetahKWArgs = {}
            allowedKWs = 'searchList namespaces filter filtersLib errorCatcher'.split()
            for k,v in KWs.items():
                if k in allowedKWs: cheetahKWArgs[k] = v
            self._initCheetahInstance(**cheetahKWArgs)
        

    def transformMatricesForDimReps(self, forwardDimRep, backwardDimRep, **KWS):



        ## CHEETAH: generated from @def transformMatricesForDimReps($forwardDimRep, $backwardDimRep) at line 26, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        write(u'''_mmt_matrix_forward  = (''')
        _v = VFFSL(SL,"matrixType",True) # u'$matrixType' on line 27, col 25
        if _v is not None: write(_filter(_v, rawExpr=u'$matrixType')) # from line 27, col 25.
        write(u''' *)xmds_malloc(sizeof(''')
        _v = VFFSL(SL,"matrixType",True) # u'$matrixType' on line 27, col 58
        if _v is not None: write(_filter(_v, rawExpr=u'$matrixType')) # from line 27, col 58.
        write(u''') * ''')
        _v = VFFSL(SL,"forwardDimRep.globalLattice",True) # u'${forwardDimRep.globalLattice}' on line 27, col 73
        if _v is not None: write(_filter(_v, rawExpr=u'${forwardDimRep.globalLattice}')) # from line 27, col 73.
        write(u''' * ''')
        _v = VFFSL(SL,"backwardDimRep.globalLattice",True) # u'${backwardDimRep.globalLattice}' on line 27, col 106
        if _v is not None: write(_filter(_v, rawExpr=u'${backwardDimRep.globalLattice}')) # from line 27, col 106.
        write(u''');
_mmt_matrix_backward = (''')
        _v = VFFSL(SL,"matrixType",True) # u'$matrixType' on line 28, col 25
        if _v is not None: write(_filter(_v, rawExpr=u'$matrixType')) # from line 28, col 25.
        write(u''' *)xmds_malloc(sizeof(''')
        _v = VFFSL(SL,"matrixType",True) # u'$matrixType' on line 28, col 58
        if _v is not None: write(_filter(_v, rawExpr=u'$matrixType')) # from line 28, col 58.
        write(u''') * ''')
        _v = VFFSL(SL,"backwardDimRep.globalLattice",True) # u'${backwardDimRep.globalLattice}' on line 28, col 73
        if _v is not None: write(_filter(_v, rawExpr=u'${backwardDimRep.globalLattice}')) # from line 28, col 73.
        write(u''' * ''')
        _v = VFFSL(SL,"forwardDimRep.globalLattice",True) # u'${forwardDimRep.globalLattice}' on line 28, col 107
        if _v is not None: write(_filter(_v, rawExpr=u'${forwardDimRep.globalLattice}')) # from line 28, col 107.
        write(u''');
for (long _i0 = 0; _i0 < ''')
        _v = VFFSL(SL,"forwardDimRep.globalLattice",True) # u'${forwardDimRep.globalLattice}' on line 29, col 26
        if _v is not None: write(_filter(_v, rawExpr=u'${forwardDimRep.globalLattice}')) # from line 29, col 26.
        write(u'''; _i0++) {
  ''')
        _v = VFFSL(SL,"transformMatricesForwardDimConstantsAtIndex",False)(forwardDimRep, backwardDimRep, '_i0') # u"${transformMatricesForwardDimConstantsAtIndex(forwardDimRep, backwardDimRep, '_i0'), autoIndent=True}" on line 30, col 3
        if _v is not None: write(_filter(_v, autoIndent=True, rawExpr=u"${transformMatricesForwardDimConstantsAtIndex(forwardDimRep, backwardDimRep, '_i0'), autoIndent=True}")) # from line 30, col 3.
        write(u'''  for (long _i1 = 0; _i1 < ''')
        _v = VFFSL(SL,"backwardDimRep.globalLattice",True) # u'${backwardDimRep.globalLattice}' on line 31, col 28
        if _v is not None: write(_filter(_v, rawExpr=u'${backwardDimRep.globalLattice}')) # from line 31, col 28.
        write(u'''; _i1++) {
    ''')
        _v = VFFSL(SL,"transformMatricesForDimRepsAtIndices",False)(forwardDimRep, backwardDimRep, '_i0', '_i1') # u"${transformMatricesForDimRepsAtIndices(forwardDimRep, backwardDimRep, '_i0', '_i1'), autoIndent=True}" on line 32, col 5
        if _v is not None: write(_filter(_v, autoIndent=True, rawExpr=u"${transformMatricesForDimRepsAtIndices(forwardDimRep, backwardDimRep, '_i0', '_i1'), autoIndent=True}")) # from line 32, col 5.
        write(u'''  }
}
''')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def transformMatricesForwardDimConstantsAtIndex(self, forwardDimRep, backwardDimRep, index, **KWS):



        ## CHEETAH: generated from @def transformMatricesForwardDimConstantsAtIndex($forwardDimRep, $backwardDimRep, $index) at line 37, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def transformMatricesForDimRepsAtIndices(self, forwardDimRep, backwardDimRep, forwardIndex, backwardIndex, **KWS):



        ## CHEETAH: generated from @def transformMatricesForDimRepsAtIndices($forwardDimRep, $backwardDimRep, $forwardIndex, $backwardIndex) at line 40, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        # 
        write(u'''_mmt_matrix_forward [''')
        _v = VFFSL(SL,"backwardIndex",True) # u'${backwardIndex}' on line 42, col 22
        if _v is not None: write(_filter(_v, rawExpr=u'${backwardIndex}')) # from line 42, col 22.
        write(u''' * ''')
        _v = VFFSL(SL,"forwardDimRep.globalLattice",True) # u'${forwardDimRep.globalLattice}' on line 42, col 41
        if _v is not None: write(_filter(_v, rawExpr=u'${forwardDimRep.globalLattice}')) # from line 42, col 41.
        write(u''' + ''')
        _v = VFFSL(SL,"forwardIndex",True) # u'${forwardIndex}' on line 42, col 74
        if _v is not None: write(_filter(_v, rawExpr=u'${forwardIndex}')) # from line 42, col 74.
        write(u'''] = \\
  ''')
        _v = VFFSL(SL,"forwardMatrixForDimAtIndices",False)(forwardDimRep, backwardDimRep, forwardIndex, backwardIndex) # u'${forwardMatrixForDimAtIndices(forwardDimRep, backwardDimRep, forwardIndex, backwardIndex)}' on line 43, col 3
        if _v is not None: write(_filter(_v, rawExpr=u'${forwardMatrixForDimAtIndices(forwardDimRep, backwardDimRep, forwardIndex, backwardIndex)}')) # from line 43, col 3.
        write(u''';
_mmt_matrix_backward[''')
        _v = VFFSL(SL,"forwardIndex",True) # u'${forwardIndex}' on line 44, col 22
        if _v is not None: write(_filter(_v, rawExpr=u'${forwardIndex}')) # from line 44, col 22.
        write(u''' * ''')
        _v = VFFSL(SL,"backwardDimRep.globalLattice",True) # u'${backwardDimRep.globalLattice}' on line 44, col 40
        if _v is not None: write(_filter(_v, rawExpr=u'${backwardDimRep.globalLattice}')) # from line 44, col 40.
        write(u''' + ''')
        _v = VFFSL(SL,"backwardIndex",True) # u'${backwardIndex}' on line 44, col 74
        if _v is not None: write(_filter(_v, rawExpr=u'${backwardIndex}')) # from line 44, col 74.
        write(u'''] = \\
  ''')
        _v = VFFSL(SL,"backwardMatrixForDimAtIndices",False)(forwardDimRep, backwardDimRep, forwardIndex, backwardIndex) # u'${backwardMatrixForDimAtIndices(forwardDimRep, backwardDimRep, forwardIndex, backwardIndex)}' on line 45, col 3
        if _v is not None: write(_filter(_v, rawExpr=u'${backwardMatrixForDimAtIndices(forwardDimRep, backwardDimRep, forwardIndex, backwardIndex)}')) # from line 45, col 3.
        write(u''';
''')
        # 
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def performTransform(self, sourceDimRep, destDimRep, dir=None, **KWS):



        ## CHEETAH: generated from @def performTransform($sourceDimRep, $destDimRep, $dir = None) at line 49, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        # 
        blasTypeChar = {'real': {'single': 's', 'double': 'd'}, 'complex': {'single': 'c', 'double': 'z'}}[self.matrixType][VFFSL(SL,"precision",True)]
        matMultFunction = 'cblas_%sgemm' % blasTypeChar
        alphaBetaPrefix = {'real': '', 'complex': '&'}[self.matrixType]
        write(u'''const ''')
        _v = VFFSL(SL,"matrixType",True) # u'${matrixType}' on line 54, col 7
        if _v is not None: write(_filter(_v, rawExpr=u'${matrixType}')) # from line 54, col 7.
        write(u''' alpha = 1.0;
const ''')
        _v = VFFSL(SL,"matrixType",True) # u'${matrixType}' on line 55, col 7
        if _v is not None: write(_filter(_v, rawExpr=u'${matrixType}')) # from line 55, col 7.
        write(u''' beta = 0.0;
''')
        _v = VFFSL(SL,"matMultFunction",True) # u'${matMultFunction}' on line 56, col 1
        if _v is not None: write(_filter(_v, rawExpr=u'${matMultFunction}')) # from line 56, col 1.
        write(u'''(
  CblasRowMajor, CblasNoTrans, CblasNoTrans,
  ''')
        _v = VFFSL(SL,"destDimRep.globalLattice",True) # u'${destDimRep.globalLattice}' on line 58, col 3
        if _v is not None: write(_filter(_v, rawExpr=u'${destDimRep.globalLattice}')) # from line 58, col 3.
        write(u''',
  /* nelem */ innerLoopSize,
  ''')
        _v = VFFSL(SL,"sourceDimRep.globalLattice",True) # u'${sourceDimRep.globalLattice}' on line 60, col 3
        if _v is not None: write(_filter(_v, rawExpr=u'${sourceDimRep.globalLattice}')) # from line 60, col 3.
        write(u''',
  /* alpha */ ''')
        _v = VFFSL(SL,"alphaBetaPrefix",True) # u'${alphaBetaPrefix}' on line 61, col 15
        if _v is not None: write(_filter(_v, rawExpr=u'${alphaBetaPrefix}')) # from line 61, col 15.
        write(u'''alpha,
  /* A */ _mmt_matrix_''')
        _v = VFFSL(SL,"dir",True) # u'${dir}' on line 62, col 23
        if _v is not None: write(_filter(_v, rawExpr=u'${dir}')) # from line 62, col 23.
        write(u''', ''')
        _v = VFFSL(SL,"sourceDimRep.globalLattice",True) # u'${sourceDimRep.globalLattice}' on line 62, col 31
        if _v is not None: write(_filter(_v, rawExpr=u'${sourceDimRep.globalLattice}')) # from line 62, col 31.
        write(u''',
  /* B */ source_data + _i0 * innerLoopSize * ''')
        _v = VFFSL(SL,"sourceDimRep.globalLattice",True) # u'${sourceDimRep.globalLattice}' on line 63, col 47
        if _v is not None: write(_filter(_v, rawExpr=u'${sourceDimRep.globalLattice}')) # from line 63, col 47.
        write(u''',
          innerLoopSize,
  /* beta */ ''')
        _v = VFFSL(SL,"alphaBetaPrefix",True) # u'${alphaBetaPrefix}' on line 65, col 14
        if _v is not None: write(_filter(_v, rawExpr=u'${alphaBetaPrefix}')) # from line 65, col 14.
        write(u'''beta,
  /* C */ dest_data + _i0 * innerLoopSize * ''')
        _v = VFFSL(SL,"destDimRep.globalLattice",True) # u'${destDimRep.globalLattice}' on line 66, col 45
        if _v is not None: write(_filter(_v, rawExpr=u'${destDimRep.globalLattice}')) # from line 66, col 45.
        write(u''',
  innerLoopSize
);
''')
        # 
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def transformFunctionStart(self, **KWS):



        ## CHEETAH: generated from @def transformFunctionStart at line 72, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        write(u'''static ''')
        _v = VFFSL(SL,"matrixType",True) # u'$matrixType' on line 73, col 8
        if _v is not None: write(_filter(_v, rawExpr=u'$matrixType')) # from line 73, col 8.
        write(u''' *_mmt_matrix_forward = NULL;
static ''')
        _v = VFFSL(SL,"matrixType",True) # u'$matrixType' on line 74, col 8
        if _v is not None: write(_filter(_v, rawExpr=u'$matrixType')) # from line 74, col 8.
        write(u''' *_mmt_matrix_backward = NULL;
''')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def transformFunction(self, transformID, transformDict, function, **KWS):



        ## CHEETAH: generated from @def transformFunction(transformID, transformDict, function) at line 77, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        # 
        transformPair = transformDict['transformPair']
        forwardDimRep = transformPair[0][0]
        backwardDimRep = transformPair[1][0]
        write(u'''static bool _initialised = false;
''')
        _v = VFFSL(SL,"transformFunctionStart",True) # u'${transformFunctionStart}' on line 83, col 1
        if _v is not None: write(_filter(_v, rawExpr=u'${transformFunctionStart}')) # from line 83, col 1.
        write(u'''ptrdiff_t innerLoopSize = _postfix_lattice;
''')
        _v = VFFSL(SL,"matrixType",True) # u'${matrixType}' on line 85, col 1
        if _v is not None: write(_filter(_v, rawExpr=u'${matrixType}')) # from line 85, col 1.
        write(u'''* const __restrict__ source_data = reinterpret_cast<''')
        _v = VFFSL(SL,"matrixType",True) # u'${matrixType}' on line 85, col 66
        if _v is not None: write(_filter(_v, rawExpr=u'${matrixType}')) # from line 85, col 66.
        write(u'''* const>(_data_in);
''')
        _v = VFFSL(SL,"matrixType",True) # u'${matrixType}' on line 86, col 1
        if _v is not None: write(_filter(_v, rawExpr=u'${matrixType}')) # from line 86, col 1.
        write(u'''* const __restrict__ dest_data = reinterpret_cast<''')
        _v = VFFSL(SL,"matrixType",True) # u'${matrixType}' on line 86, col 64
        if _v is not None: write(_filter(_v, rawExpr=u'${matrixType}')) # from line 86, col 64.
        write(u'''* const>(_data_out);

if (!_initialised) {
  _LOG(_SIMULATION_LOG_LEVEL, "Building matrices for ''')
        _v = VFFSL(SL,"function.description",True) # u'${function.description}' on line 89, col 54
        if _v is not None: write(_filter(_v, rawExpr=u'${function.description}')) # from line 89, col 54.
        write(u'''...");
  
  ''')
        _v = VFFSL(SL,"transformMatricesForDimReps",False)(VFFSL(SL,"forwardDimRep",True), VFFSL(SL,"backwardDimRep",True)) # u'${transformMatricesForDimReps($forwardDimRep, $backwardDimRep), autoIndent=True}' on line 91, col 3
        if _v is not None: write(_filter(_v, autoIndent=True, rawExpr=u'${transformMatricesForDimReps($forwardDimRep, $backwardDimRep), autoIndent=True}')) # from line 91, col 3.
        write(u'''  
  _LOG(_SIMULATION_LOG_LEVEL, " done.\\n");
  _initialised = true;
}

if (_forward) {
  for (long _i0 = 0; _i0 < _prefix_lattice; _i0++) {
    ''')
        _v = VFFSL(SL,"performTransform",False)(forwardDimRep, backwardDimRep, dir='forward') # u"${performTransform(forwardDimRep, backwardDimRep, dir='forward'), autoIndent=True}" on line 99, col 5
        if _v is not None: write(_filter(_v, autoIndent=True, rawExpr=u"${performTransform(forwardDimRep, backwardDimRep, dir='forward'), autoIndent=True}")) # from line 99, col 5.
        write(u'''  }
} else {
  for (long _i0 = 0; _i0 < _prefix_lattice; _i0++) {
    ''')
        _v = VFFSL(SL,"performTransform",False)(backwardDimRep, forwardDimRep, dir='backward') # u"${performTransform(backwardDimRep, forwardDimRep, dir='backward'), autoIndent=True}" on line 103, col 5
        if _v is not None: write(_filter(_v, autoIndent=True, rawExpr=u"${performTransform(backwardDimRep, forwardDimRep, dir='backward'), autoIndent=True}")) # from line 103, col 5.
        write(u'''  }
}
''')
        # 
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def writeBody(self, **KWS):



        ## CHEETAH: main method generated for this template
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        # 
        # Basis.tmpl
        # 
        # Created by Graham Dennis on 2008-12-14.
        # 
        # Copyright (c) 2008-2012, Graham Dennis
        # 
        # This program is free software: you can redistribute it and/or modify
        # it under the terms of the GNU General Public License as published by
        # the Free Software Foundation, either version 2 of the License, or
        # (at your option) any later version.
        # 
        # This program is distributed in the hope that it will be useful,
        # but WITHOUT ANY WARRANTY; without even the implied warranty of
        # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
        # GNU General Public License for more details.
        # 
        # You should have received a copy of the GNU General Public License
        # along with this program.  If not, see <http://www.gnu.org/licenses/>.
        # 
        write(u'''






''')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        
    ##################################################
    ## CHEETAH GENERATED ATTRIBUTES


    _CHEETAH__instanceInitialized = False

    _CHEETAH_version = __CHEETAH_version__

    _CHEETAH_versionTuple = __CHEETAH_versionTuple__

    _CHEETAH_genTime = __CHEETAH_genTime__

    _CHEETAH_genTimestamp = __CHEETAH_genTimestamp__

    _CHEETAH_src = __CHEETAH_src__

    _CHEETAH_srcLastModified = __CHEETAH_srcLastModified__

    matrixType = 'real'

    _mainCheetahMethod_for_Basis= 'writeBody'

## END CLASS DEFINITION

if not hasattr(Basis, '_initCheetahAttributes'):
    templateAPIClass = getattr(Basis, '_CHEETAH_templateClass', Template)
    templateAPIClass._addCheetahPlumbingCodeToClass(Basis)


# CHEETAH was developed by Tavis Rudd and Mike Orr
# with code, advice and input from many other volunteers.
# For more information visit http://www.CheetahTemplate.org/

##################################################
## if run from command line:
if __name__ == '__main__':
    from Cheetah.TemplateCmdLineIface import CmdLineIface
    CmdLineIface(templateObj=Basis()).run()


