#!/usr/bin/env python




##################################################
## DEPENDENCIES
import sys
import os
import os.path
try:
    import builtins as builtin
except ImportError:
    import __builtin__ as builtin
from os.path import getmtime, exists
import time
import types
from Cheetah.Version import MinCompatibleVersion as RequiredCheetahVersion
from Cheetah.Version import MinCompatibleVersionTuple as RequiredCheetahVersionTuple
from Cheetah.Template import Template
from Cheetah.DummyTransaction import *
from Cheetah.NameMapper import NotFound, valueForName, valueFromSearchList, valueFromFrameOrSearchList
from Cheetah.CacheRegion import CacheRegion
import Cheetah.Filters as Filters
import Cheetah.ErrorCatchers as ErrorCatchers
from xpdeint.Operators._IPOperator import _IPOperator

##################################################
## MODULE CONSTANTS
VFFSL=valueFromFrameOrSearchList
VFSL=valueFromSearchList
VFN=valueForName
currentTime=time.time
__CHEETAH_version__ = '2.4.4'
__CHEETAH_versionTuple__ = (2, 4, 4, 'development', 0)
__CHEETAH_genTime__ = 1350619621.427395
__CHEETAH_genTimestamp__ = 'Fri Oct 19 15:07:01 2012'
__CHEETAH_src__ = '/Users/graham/Library/XMDS/src/xmds2/admin/staging/xmds-2.1.2/xpdeint/Operators/ConstantIPOperator.tmpl'
__CHEETAH_srcLastModified__ = 'Mon Jul 23 09:42:26 2012'
__CHEETAH_docstring__ = 'Autogenerated by Cheetah: The Python-Powered Template Engine'

if __CHEETAH_versionTuple__ < RequiredCheetahVersionTuple:
    raise AssertionError(
      'This template was compiled with Cheetah version'
      ' %s. Templates compiled before version %s must be recompiled.'%(
         __CHEETAH_version__, RequiredCheetahVersion))

##################################################
## CLASSES

class ConstantIPOperator(_IPOperator):

    ##################################################
    ## CHEETAH GENERATED METHODS


    def __init__(self, *args, **KWs):

        super(ConstantIPOperator, self).__init__(*args, **KWs)
        if not self._CHEETAH__instanceInitialized:
            cheetahKWArgs = {}
            allowedKWs = 'searchList namespaces filter filtersLib errorCatcher'.split()
            for k,v in KWs.items():
                if k in allowedKWs: cheetahKWArgs[k] = v
            self._initCheetahInstance(**cheetahKWArgs)
        

    def calculateOperatorFieldFunctionContents(self, function, **KWS):



        ## CHEETAH: generated from @def calculateOperatorFieldFunctionContents($function) at line 28, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        # 
        _v = VFFSL(SL,"integrator.createStepVariable",True) # u'${integrator.createStepVariable}' on line 30, col 1
        if _v is not None: write(_filter(_v, rawExpr=u'${integrator.createStepVariable}')) # from line 30, col 1.
        write(u'''
''')
        _v = super(ConstantIPOperator, self).calculateOperatorFieldFunctionContents(function)
        if _v is not None: write(_filter(_v))
        # 
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def insideCalculateOperatorFieldLoops(self, codeString, **KWS):



        ## CHEETAH: generated from @def insideCalculateOperatorFieldLoops($codeString) at line 37, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        # 
        _v = VFFSL(SL,"insideCalculateOperatorFieldLoopsBegin",True) # u'${insideCalculateOperatorFieldLoopsBegin}' on line 39, col 1
        if _v is not None: write(_filter(_v, rawExpr=u'${insideCalculateOperatorFieldLoopsBegin}')) # from line 39, col 1.
        # 
        #  We expect the integrator to have defined '_step'
        # 
        write(u'''// ************** Operator code *****************
''')
        _v = VFFSL(SL,"codeString",True) # u'${codeString}' on line 44, col 1
        if _v is not None: write(_filter(_v, rawExpr=u'${codeString}')) # from line 44, col 1.
        write(u'''// **********************************************
''')
        #  Loop over the propagation step fractions
        for fractionIndex, propagationStepFraction in enumerate(VFFSL(SL,"integrator.ipPropagationStepFractions",True)): # generated from line 47, col 3
            write(u'''    
''')
            #  Loop over each operator component
            for operatorComponentNumber, operatorComponent in enumerate(VFN(VFFSL(SL,"operatorComponents",True),"iterkeys",False)()): # generated from line 50, col 5
                offsetIndex = VFFSL(SL,"operatorComponentNumber",True) + VFFSL(SL,"fractionIndex",True) * len(VFFSL(SL,"operatorComponents",True))
                write(u'''_''')
                _v = VFFSL(SL,"operatorVector.id",True) # u'${operatorVector.id}' on line 52, col 2
                if _v is not None: write(_filter(_v, rawExpr=u'${operatorVector.id}')) # from line 52, col 2.
                write(u'''[_''')
                _v = VFFSL(SL,"operatorVector.id",True) # u'${operatorVector.id}' on line 52, col 24
                if _v is not None: write(_filter(_v, rawExpr=u'${operatorVector.id}')) # from line 52, col 24.
                write(u'''_index_pointer + ''')
                _v = VFFSL(SL,"offsetIndex",True) # u'${offsetIndex}' on line 52, col 61
                if _v is not None: write(_filter(_v, rawExpr=u'${offsetIndex}')) # from line 52, col 61.
                write(u'''] = ''')
                _v = VFFSL(SL,"expFunction",True) # u'${expFunction}' on line 52, col 79
                if _v is not None: write(_filter(_v, rawExpr=u'${expFunction}')) # from line 52, col 79.
                write(u'''(''')
                _v = VFFSL(SL,"operatorComponent",True) # u'${operatorComponent}' on line 52, col 94
                if _v is not None: write(_filter(_v, rawExpr=u'${operatorComponent}')) # from line 52, col 94.
                _v = VFFSL(SL,"valueSuffix",True) # u'${valueSuffix}' on line 52, col 114
                if _v is not None: write(_filter(_v, rawExpr=u'${valueSuffix}')) # from line 52, col 114.
                write(u''' * ''')
                _v = VFFSL(SL,"propagationStepFraction",True) # u'$propagationStepFraction' on line 52, col 131
                if _v is not None: write(_filter(_v, rawExpr=u'$propagationStepFraction')) # from line 52, col 131.
                write(u''' * _step);
''')
        # 
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def evaluateOperatorLoop(self, setOfVectorsToLoopOver, **KWS):



        ## CHEETAH: generated from @def evaluateOperatorLoop($setOfVectorsToLoopOver) at line 58, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        # 
        #  We expect the integrator to have defined _exponent
        # 
        if len(VFFSL(SL,"integrator.ipPropagationStepFractions",True)) > 1: # generated from line 62, col 3
            write(u'''unsigned long _exponentIndex = (abs(_exponent) - 1) * ''')
            _v = VFFSL(SL,"len",False)(VFFSL(SL,"operatorComponents",True)) # u'$len($operatorComponents)' on line 63, col 55
            if _v is not None: write(_filter(_v, rawExpr=u'$len($operatorComponents)')) # from line 63, col 55.
            write(u''';

''')
        write(u'''if (_exponent > 0) {
  ''')
        _v = VFFSL(SL,"loopOverVectorsInBasisWithInnerContent",False)(VFFSL(SL,"setOfVectorsToLoopOver",True), VFFSL(SL,"operatorBasis",True), VFFSL(SL,"insideEvaluateOperatorLoops",False)('*')) # u"${loopOverVectorsInBasisWithInnerContent($setOfVectorsToLoopOver, $operatorBasis, $insideEvaluateOperatorLoops('*')), autoIndent=True}" on line 67, col 3
        if _v is not None: write(_filter(_v, autoIndent=True, rawExpr=u"${loopOverVectorsInBasisWithInnerContent($setOfVectorsToLoopOver, $operatorBasis, $insideEvaluateOperatorLoops('*')), autoIndent=True}")) # from line 67, col 3.
        write(u'''} else {
  ''')
        _v = VFFSL(SL,"loopOverVectorsInBasisWithInnerContent",False)(VFFSL(SL,"setOfVectorsToLoopOver",True), VFFSL(SL,"operatorBasis",True), VFFSL(SL,"insideEvaluateOperatorLoops",False)('/')) # u"${loopOverVectorsInBasisWithInnerContent($setOfVectorsToLoopOver, $operatorBasis, $insideEvaluateOperatorLoops('/')), autoIndent=True}" on line 69, col 3
        if _v is not None: write(_filter(_v, autoIndent=True, rawExpr=u"${loopOverVectorsInBasisWithInnerContent($setOfVectorsToLoopOver, $operatorBasis, $insideEvaluateOperatorLoops('/')), autoIndent=True}")) # from line 69, col 3.
        write(u'''}
''')
        # 
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def insideEvaluateOperatorLoops(self, operationString, **KWS):



        ## CHEETAH: generated from @def insideEvaluateOperatorLoops($operationString) at line 74, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        # 
        _v = VFFSL(SL,"insideEvaluateOperatorLoopsBegin",True) # u'${insideEvaluateOperatorLoopsBegin}' on line 76, col 1
        if _v is not None: write(_filter(_v, rawExpr=u'${insideEvaluateOperatorLoopsBegin}')) # from line 76, col 1.
        # 
        for operatorComponentNumber, (operatorComponentName, operatorComponentVectors) in enumerate(VFN(VFFSL(SL,"operatorComponents",True),"iteritems",False)()): # generated from line 78, col 3
            for targetVectorComponents in operatorComponentVectors.itervalues(): # generated from line 79, col 5
                for targetVectorComponent in targetVectorComponents: # generated from line 80, col 7
                    write(u'''// ''')
                    _v = VFFSL(SL,"operatorComponentName",True) # u'${operatorComponentName}' on line 81, col 4
                    if _v is not None: write(_filter(_v, rawExpr=u'${operatorComponentName}')) # from line 81, col 4.
                    write(u'''[''')
                    _v = VFFSL(SL,"targetVectorComponent",True) # u'$targetVectorComponent' on line 81, col 29
                    if _v is not None: write(_filter(_v, rawExpr=u'$targetVectorComponent')) # from line 81, col 29.
                    write(u''']
''')
                    _v = VFFSL(SL,"targetVectorComponent",True) # u'$targetVectorComponent' on line 82, col 1
                    if _v is not None: write(_filter(_v, rawExpr=u'$targetVectorComponent')) # from line 82, col 1.
                    write(u''' ''')
                    _v = VFFSL(SL,"operationString",True) # u'${operationString}' on line 82, col 24
                    if _v is not None: write(_filter(_v, rawExpr=u'${operationString}')) # from line 82, col 24.
                    write(u'''= _''')
                    _v = VFFSL(SL,"operatorVector.id",True) # u'${operatorVector.id}' on line 82, col 45
                    if _v is not None: write(_filter(_v, rawExpr=u'${operatorVector.id}')) # from line 82, col 45.
                    write(u'''[_''')
                    _v = VFFSL(SL,"operatorVector.id",True) # u'${operatorVector.id}' on line 82, col 67
                    if _v is not None: write(_filter(_v, rawExpr=u'${operatorVector.id}')) # from line 82, col 67.
                    write(u'''_index_pointer + ''')
                    _v = VFFSL(SL,"operatorComponentNumber",True) # u'$operatorComponentNumber' on line 82, col 104
                    if _v is not None: write(_filter(_v, rawExpr=u'$operatorComponentNumber')) # from line 82, col 104.
                    if len(VFFSL(SL,"integrator.ipPropagationStepFractions",True)) > 1: # generated from line 83, col 9
                        write(u''' + _exponentIndex''')
                    write(u'''];
''')
        # 
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def writeBody(self, **KWS):



        ## CHEETAH: main method generated for this template
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        # 
        # ConstantIPOperator.tmpl
        # 
        # Interaction-picture transverse derivative operator
        # 
        # Created by Graham Dennis on 2007-10-06.
        # 
        # Copyright (c) 2007-2012, Graham Dennis
        # 
        # This program is free software: you can redistribute it and/or modify
        # it under the terms of the GNU General Public License as published by
        # the Free Software Foundation, either version 2 of the License, or
        # (at your option) any later version.
        # 
        # This program is distributed in the hope that it will be useful,
        # but WITHOUT ANY WARRANTY; without even the implied warranty of
        # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
        # GNU General Public License for more details.
        # 
        # You should have received a copy of the GNU General Public License
        # along with this program.  If not, see <http://www.gnu.org/licenses/>.
        # 
        write(u'''





''')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        
    ##################################################
    ## CHEETAH GENERATED ATTRIBUTES


    _CHEETAH__instanceInitialized = False

    _CHEETAH_version = __CHEETAH_version__

    _CHEETAH_versionTuple = __CHEETAH_versionTuple__

    _CHEETAH_genTime = __CHEETAH_genTime__

    _CHEETAH_genTimestamp = __CHEETAH_genTimestamp__

    _CHEETAH_src = __CHEETAH_src__

    _CHEETAH_srcLastModified = __CHEETAH_srcLastModified__

    calculateOperatorFieldFunctionArguments = []

    _mainCheetahMethod_for_ConstantIPOperator= 'writeBody'

## END CLASS DEFINITION

if not hasattr(ConstantIPOperator, '_initCheetahAttributes'):
    templateAPIClass = getattr(ConstantIPOperator, '_CHEETAH_templateClass', Template)
    templateAPIClass._addCheetahPlumbingCodeToClass(ConstantIPOperator)


# CHEETAH was developed by Tavis Rudd and Mike Orr
# with code, advice and input from many other volunteers.
# For more information visit http://www.CheetahTemplate.org/

##################################################
## if run from command line:
if __name__ == '__main__':
    from Cheetah.TemplateCmdLineIface import CmdLineIface
    CmdLineIface(templateObj=ConstantIPOperator()).run()


