#!/usr/bin/env python




##################################################
## DEPENDENCIES
import sys
import os
import os.path
try:
    import builtins as builtin
except ImportError:
    import __builtin__ as builtin
from os.path import getmtime, exists
import time
import types
from Cheetah.Version import MinCompatibleVersion as RequiredCheetahVersion
from Cheetah.Version import MinCompatibleVersionTuple as RequiredCheetahVersionTuple
from Cheetah.Template import Template
from Cheetah.DummyTransaction import *
from Cheetah.NameMapper import NotFound, valueForName, valueFromSearchList, valueFromFrameOrSearchList
from Cheetah.CacheRegion import CacheRegion
import Cheetah.Filters as Filters
import Cheetah.ErrorCatchers as ErrorCatchers

##################################################
## MODULE CONSTANTS
VFFSL=valueFromFrameOrSearchList
VFSL=valueFromSearchList
VFN=valueForName
currentTime=time.time
__CHEETAH_version__ = '2.4.4'
__CHEETAH_versionTuple__ = (2, 4, 4, 'development', 0)
__CHEETAH_genTime__ = 1350619623.578584
__CHEETAH_genTimestamp__ = 'Fri Oct 19 15:07:03 2012'
__CHEETAH_src__ = '/Users/graham/Library/XMDS/src/xmds2/admin/staging/xmds-2.1.2/xpdeint/xsil2graphics2/MatlabImport.tmpl'
__CHEETAH_srcLastModified__ = 'Sat Feb  4 18:39:07 2012'
__CHEETAH_docstring__ = 'Autogenerated by Cheetah: The Python-Powered Template Engine'

if __CHEETAH_versionTuple__ < RequiredCheetahVersionTuple:
    raise AssertionError(
      'This template was compiled with Cheetah version'
      ' %s. Templates compiled before version %s must be recompiled.'%(
         __CHEETAH_version__, RequiredCheetahVersion))

##################################################
## CLASSES

class MatlabImport(Template):

    ##################################################
    ## CHEETAH GENERATED METHODS


    def __init__(self, *args, **KWs):

        super(MatlabImport, self).__init__(*args, **KWs)
        if not self._CHEETAH__instanceInitialized:
            cheetahKWArgs = {}
            allowedKWs = 'searchList namespaces filter filtersLib errorCatcher'.split()
            for k,v in KWs.items():
                if k in allowedKWs: cheetahKWArgs[k] = v
            self._initCheetahInstance(**cheetahKWArgs)
        

    def description(self, **KWS):



        ## Generated from @def description: Creates text to import data from XSIL files into Matlab. at line 24, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        write(u'''Creates text to import data from XSIL files into Matlab.''')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def loadXSILFile(self, xsilFile, **KWS):



        ## CHEETAH: generated from @def loadXSILFile($xsilFile) at line 29, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        for objectNum, xsilObject in enumerate(xsilFile.xsilObjects): # generated from line 30, col 3
            if xsilObject.data.format == 'hdf5': # generated from line 31, col 5
                filename = xsilObject.data.filename
                groupName = xsilObject.data.groupName
                for var in xsilObject.independentVariables: # generated from line 34, col 7
                    outName = ''.join([str(VFFSL(SL,"var.name",True)),u'_',str(VFFSL(SL,"objectNum",True)+1)])
                    _v = VFFSL(SL,"outName",True) # u'${outName}' on line 36, col 1
                    if _v is not None: write(_filter(_v, rawExpr=u'${outName}')) # from line 36, col 1.
                    write(u""" = hdf5read('""")
                    _v = VFFSL(SL,"filename",True) # u'${filename}' on line 36, col 24
                    if _v is not None: write(_filter(_v, rawExpr=u'${filename}')) # from line 36, col 24.
                    write(u"""', '""")
                    _v = VFFSL(SL,"groupName",True) # u'${groupName}' on line 36, col 39
                    if _v is not None: write(_filter(_v, rawExpr=u'${groupName}')) # from line 36, col 39.
                    write(u'''/''')
                    _v = VFFSL(SL,"var.name",True) # u'${var.name}' on line 36, col 52
                    if _v is not None: write(_filter(_v, rawExpr=u'${var.name}')) # from line 36, col 52.
                    write(u"""');
""")
                for var in xsilObject.dependentVariables: # generated from line 38, col 7
                    outName = ''.join([str(VFFSL(SL,"var.name",True)),u'_',str(VFFSL(SL,"objectNum",True)+1)])
                    _v = VFFSL(SL,"outName",True) # u'${outName}' on line 40, col 1
                    if _v is not None: write(_filter(_v, rawExpr=u'${outName}')) # from line 40, col 1.
                    write(u""" = hdf5read('""")
                    _v = VFFSL(SL,"filename",True) # u'${filename}' on line 40, col 24
                    if _v is not None: write(_filter(_v, rawExpr=u'${filename}')) # from line 40, col 24.
                    write(u"""', '""")
                    _v = VFFSL(SL,"groupName",True) # u'${groupName}' on line 40, col 39
                    if _v is not None: write(_filter(_v, rawExpr=u'${groupName}')) # from line 40, col 39.
                    write(u'''/''')
                    _v = VFFSL(SL,"var.name",True) # u'${var.name}' on line 40, col 52
                    if _v is not None: write(_filter(_v, rawExpr=u'${var.name}')) # from line 40, col 52.
                    write(u"""');
""")
                    _v = VFFSL(SL,"outName",True) # u'${outName}' on line 41, col 1
                    if _v is not None: write(_filter(_v, rawExpr=u'${outName}')) # from line 41, col 1.
                    write(u''' = permute(''')
                    _v = VFFSL(SL,"outName",True) # u'${outName}' on line 41, col 22
                    if _v is not None: write(_filter(_v, rawExpr=u'${outName}')) # from line 41, col 22.
                    write(u''', ndims(''')
                    _v = VFFSL(SL,"outName",True) # u'${outName}' on line 41, col 40
                    if _v is not None: write(_filter(_v, rawExpr=u'${outName}')) # from line 41, col 40.
                    write(u'''):-1:1);
''')
            else: # generated from line 43, col 5
                raise Exception("No support for Matlab output for XSIL format '%s'." % xsilObject.data.format)
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def respond(self, trans=None):



        ## CHEETAH: main method generated for this template
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        # 
        # MatlabImport.tmpl
        # 
        # Created by Joe Hope on 2009-01-07.
        # Modified by Graham Dennis on 2009-01-29
        # 
        # Copyright (c) 2009-2012, Joe Hope and Graham Dennis
        # 
        # This program is free software: you can redistribute it and/or modify
        # it under the terms of the GNU General Public License as published by
        # the Free Software Foundation, either version 2 of the License, or
        # (at your option) any later version.
        # 
        # This program is distributed in the hope that it will be useful,
        # but WITHOUT ANY WARRANTY; without even the implied warranty of
        # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
        # GNU General Public License for more details.
        # 
        # You should have received a copy of the GNU General Public License
        # along with this program.  If not, see <http://www.gnu.org/licenses/>.
        # 
        write(u'''



''')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        
    ##################################################
    ## CHEETAH GENERATED ATTRIBUTES


    _CHEETAH__instanceInitialized = False

    _CHEETAH_version = __CHEETAH_version__

    _CHEETAH_versionTuple = __CHEETAH_versionTuple__

    _CHEETAH_genTime = __CHEETAH_genTime__

    _CHEETAH_genTimestamp = __CHEETAH_genTimestamp__

    _CHEETAH_src = __CHEETAH_src__

    _CHEETAH_srcLastModified = __CHEETAH_srcLastModified__

    name = 'Matlab'

    defaultExtension = 'm'

    _mainCheetahMethod_for_MatlabImport= 'respond'

## END CLASS DEFINITION

if not hasattr(MatlabImport, '_initCheetahAttributes'):
    templateAPIClass = getattr(MatlabImport, '_CHEETAH_templateClass', Template)
    templateAPIClass._addCheetahPlumbingCodeToClass(MatlabImport)


# CHEETAH was developed by Tavis Rudd and Mike Orr
# with code, advice and input from many other volunteers.
# For more information visit http://www.CheetahTemplate.org/

##################################################
## if run from command line:
if __name__ == '__main__':
    from Cheetah.TemplateCmdLineIface import CmdLineIface
    CmdLineIface(templateObj=MatlabImport()).run()


