#!/usr/bin/env python




##################################################
## DEPENDENCIES
import sys
import os
import os.path
try:
    import builtins as builtin
except ImportError:
    import __builtin__ as builtin
from os.path import getmtime, exists
import time
import types
from Cheetah.Version import MinCompatibleVersion as RequiredCheetahVersion
from Cheetah.Version import MinCompatibleVersionTuple as RequiredCheetahVersionTuple
from Cheetah.Template import Template
from Cheetah.DummyTransaction import *
from Cheetah.NameMapper import NotFound, valueForName, valueFromSearchList, valueFromFrameOrSearchList
from Cheetah.CacheRegion import CacheRegion
import Cheetah.Filters as Filters
import Cheetah.ErrorCatchers as ErrorCatchers

##################################################
## MODULE CONSTANTS
VFFSL=valueFromFrameOrSearchList
VFSL=valueFromSearchList
VFN=valueForName
currentTime=time.time
__CHEETAH_version__ = '2.4.4'
__CHEETAH_versionTuple__ = (2, 4, 4, 'development', 0)
__CHEETAH_genTime__ = 1350619623.660819
__CHEETAH_genTimestamp__ = 'Fri Oct 19 15:07:03 2012'
__CHEETAH_src__ = '/Users/graham/Library/XMDS/src/xmds2/admin/staging/xmds-2.1.2/xpdeint/xsil2graphics2/OctaveImport.tmpl'
__CHEETAH_srcLastModified__ = 'Fri Aug  3 17:06:25 2012'
__CHEETAH_docstring__ = 'Autogenerated by Cheetah: The Python-Powered Template Engine'

if __CHEETAH_versionTuple__ < RequiredCheetahVersionTuple:
    raise AssertionError(
      'This template was compiled with Cheetah version'
      ' %s. Templates compiled before version %s must be recompiled.'%(
         __CHEETAH_version__, RequiredCheetahVersion))

##################################################
## CLASSES

class OctaveImport(Template):

    ##################################################
    ## CHEETAH GENERATED METHODS


    def __init__(self, *args, **KWs):

        super(OctaveImport, self).__init__(*args, **KWs)
        if not self._CHEETAH__instanceInitialized:
            cheetahKWArgs = {}
            allowedKWs = 'searchList namespaces filter filtersLib errorCatcher'.split()
            for k,v in KWs.items():
                if k in allowedKWs: cheetahKWArgs[k] = v
            self._initCheetahInstance(**cheetahKWArgs)
        

    def description(self, **KWS):



        ## Generated from @def description: Creates text to import data from XSIL files into GNU Octave. at line 8, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        write(u'''Creates text to import data from XSIL files into GNU Octave.''')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def loadXSILFile(self, xsilFile, **KWS):



        ## CHEETAH: generated from @def loadXSILFile($xsilFile) at line 13, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        for objectNum, xsilObject in enumerate(xsilFile.xsilObjects): # generated from line 14, col 3
            if xsilObject.data.format == 'hdf5': # generated from line 15, col 5
                filename = xsilObject.data.filename
                write(u'''load ''')
                _v = VFFSL(SL,"filename",True) # u'${filename}' on line 17, col 6
                if _v is not None: write(_filter(_v, rawExpr=u'${filename}')) # from line 17, col 6.
                write(u'''
''')
                for var in xsilObject.independentVariables: # generated from line 18, col 7
                    outName = ''.join([str(VFFSL(SL,"var.name",True)),u'_',str(VFFSL(SL,"objectNum",True)+1)])
                    _v = VFFSL(SL,"var.name",True) # u'${var.name}' on line 20, col 1
                    if _v is not None: write(_filter(_v, rawExpr=u'${var.name}')) # from line 20, col 1.
                    write(u''' = _''')
                    _v = VFFSL(SL,"objectNum",True)+1 # u'${objectNum+1}' on line 20, col 16
                    if _v is not None: write(_filter(_v, rawExpr=u'${objectNum+1}')) # from line 20, col 16.
                    write(u'''.''')
                    _v = VFFSL(SL,"var.name",True) # u'${var.name}' on line 20, col 31
                    if _v is not None: write(_filter(_v, rawExpr=u'${var.name}')) # from line 20, col 31.
                    write(u''';
''')
                for var in xsilObject.dependentVariables: # generated from line 22, col 7
                    _v = VFFSL(SL,"var.name",True) # u'${var.name}' on line 23, col 1
                    if _v is not None: write(_filter(_v, rawExpr=u'${var.name}')) # from line 23, col 1.
                    write(u''' = _''')
                    _v = VFFSL(SL,"objectNum",True)+1 # u'${objectNum+1}' on line 23, col 16
                    if _v is not None: write(_filter(_v, rawExpr=u'${objectNum+1}')) # from line 23, col 16.
                    write(u'''.''')
                    _v = VFFSL(SL,"var.name",True) # u'${var.name}' on line 23, col 31
                    if _v is not None: write(_filter(_v, rawExpr=u'${var.name}')) # from line 23, col 31.
                    write(u''';
''')
            else: # generated from line 25, col 5
                raise Exception("No support for Octave output for XSIL format '%s'." % xsilObject.data.format)
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def respond(self, trans=None):



        ## CHEETAH: main method generated for this template
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        # 
        # OctaveImport.tmpl
        # 
        # Created by Lincoln Turner on 2011-02-01.
        # Copyright (c) 2011 Monash University. All rights reserved.
        write(u'''



''')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        
    ##################################################
    ## CHEETAH GENERATED ATTRIBUTES


    _CHEETAH__instanceInitialized = False

    _CHEETAH_version = __CHEETAH_version__

    _CHEETAH_versionTuple = __CHEETAH_versionTuple__

    _CHEETAH_genTime = __CHEETAH_genTime__

    _CHEETAH_genTimestamp = __CHEETAH_genTimestamp__

    _CHEETAH_src = __CHEETAH_src__

    _CHEETAH_srcLastModified = __CHEETAH_srcLastModified__

    name = 'Octave'

    defaultExtension = 'm'

    _mainCheetahMethod_for_OctaveImport= 'respond'

## END CLASS DEFINITION

if not hasattr(OctaveImport, '_initCheetahAttributes'):
    templateAPIClass = getattr(OctaveImport, '_CHEETAH_templateClass', Template)
    templateAPIClass._addCheetahPlumbingCodeToClass(OctaveImport)


# CHEETAH was developed by Tavis Rudd and Mike Orr
# with code, advice and input from many other volunteers.
# For more information visit http://www.CheetahTemplate.org/

##################################################
## if run from command line:
if __name__ == '__main__':
    from Cheetah.TemplateCmdLineIface import CmdLineIface
    CmdLineIface(templateObj=OctaveImport()).run()


